#include "Effect.h"
#include "effect_big_clock.h"
#include "text.h"
#include "functions.h"
#include "ntp.h"

void BigClockEffect::drawNumber(uint8_t number, int x, int y, CRGB color) {
  char buffer[7];
  sprintf(buffer, "%02d", number);
  drawText(buffer, x, y, color);
}

void BigClockEffect::drawText(char *text, int x, int y, CRGB color) {
  for (int i = 0; i < strlen(text); i++) {
    drawSprite(font_char(numbers4x7, text[i]), x + i * 4, y, color);
  }
}

unsigned char* BigClockEffect::font_char(unsigned char* font, char c) {
  return &font[(c - 48) * 4];
}

void BigClockEffect::drawSprite(unsigned char* sprite, int xOffset, int yOffset, CRGB color) {
  for ( byte y = 0; y < 7; y++) {
    for ( byte x = 0; x < 4; x++) {
      bool on = (sprite[x] >> y & 1) * 255;
      if (on) {
        leds[ XYsafe(x + xOffset, y + yOffset) ] = color;
      }
    }
  }
}

void BigClockEffect::loop() {
  clear();
  drawNumber(ntpClient.getHours(), 0, 0, color_h);
  drawNumber(ntpClient.getMinutes(), 8, 0, color_m);
  /*if (ntpClient.getSeconds() & 1) {
    leds[XYsafe(13, 2)] = color_colon;
    leds[XYsafe(13, 5)] = color_colon;
    }*/
  drawNumber(ntpClient.getSeconds(), 8, 8, color_colon);
}
